<?php

# PHP class for sending orders to the pxprint.net service
# Version: 1.0.1
# Date: 2012-07-02
#
# Copyright (c) 2012 Virthos Systems GmbH
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE


class Pxprint {
	
	var $shop_id;
	var $security_key;
	var $base_url;

	function Pxprint( $shop_id, $security_key, $base_url = '' )
	{
		$this->shop_id = $shop_id;
		$this->security_key = $security_key;
		$this->base_url = $base_url;
	}

	function create_order( $items, $subject = '', $delivery = NULL, $contact = NULL )
	{
		$timestamp = time();
		if ( is_array( $items ) )
		{
			$items = json_encode( $items );
		}
		$request  = 'shop_id=' . $this->shop_id;
		$request .= '&items=' . urlencode( $items );
		$request .= '&timestamp=' . $timestamp;
		$request .= '&hash=' . md5( $this->shop_id . $items . $timestamp . $this->security_key );
		$request .= '&base_url=' . urlencode( $this->base_url );
		$request .= '&subject=' . urlencode( $subject );
	
		$request .= '&inv_lastname=' . urlencode( $contact['lastname'] );
		$request .= '&inv_firstname=' . urlencode( $contact['firstname'] );
		$request .= '&inv_organization=' . urlencode( $contact['organization'] );
		$request .= '&inv_address=' . urlencode( $contact['address'] );
		$request .= '&inv_city=' . urlencode( $contact['city'] );
		$request .= '&inv_zipcode=' . urlencode( $contact['zipcode'] );
		$request .= '&inv_country=' . urlencode( $contact['country'] );
		$request .= '&inv_state=' . urlencode( $contact['state'] );
		$request .= '&phone=' . urlencode( $contact['phone'] );
		$request .= '&email=' . urlencode( $contact['email'] );
	
		if ( ! $delivery )
		{
			$request .= '&ship_to_enduser=0' ;
		}
		else
		{
			$request .= '&ship_to_enduser=1' ;
			$request .= '&del_lastname=' . urlencode( $delivery['lastname'] );
			$request .= '&del_firstname=' . urlencode( $delivery['firstname'] );
			$request .= '&del_organization=' . urlencode( $delivery['organization'] );
			$request .= '&del_address=' . urlencode( $delivery['address'] );
			$request .= '&del_city=' . urlencode( $delivery['city'] );
			$request .= '&del_zipcode=' . urlencode( $delivery['zipcode'] );
			$request .= '&del_country=' . urlencode( $delivery['country'] );
			$request .= '&del_state=' . urlencode( $delivery['state'] );
		}

		$header  = "POST /index.php/api/create HTTP/1.0\r\n"; 
	 	$header .= "Host: api.pxprint.net\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n"; 
		$header .= "Content-Length: " . strlen( $request ) . "\r\n"; 
		$header .= "Connection: close\r\n\r\n"; 

		$fp = fsockopen( 'api.pxprint.net', 80, $errno, $errstr, 30 );
		if ( ! $fp )
		{ 
			return '-1'; // Verbindung konnte nicht hergestellt werden
		}
		else
		{ 
			fwrite( $fp, $header . $request );
			$result = '';
			while ( ! feof( $fp ) )
			{ 
			  $result .= fgets( $fp, 128 );
			}
			fclose( $fp );
			$lines = explode( "\n", $result );
			end( $lines );
			if ( strpos( $lines[0], '200' ) > 0 )
			{
				return current( $lines );
			}
			else
			{
				return '-2 '; // Anfrage lieferte einen Statuscode <> 200 zurck
			}
		}
	}


}
// End of file